Loading...
Searching...
No Matches
juce::URL::InputStreamOptions Class Reference

## Detailed Description

Class used to create a set of options to pass to the createInputStream() method.

You can chain together a series of calls to this class's methods to create a set of whatever options you want to specify, e.g.

if (auto inputStream = URL ("http://www.xyz.com/foobar")
.createInputStream (URL::InputStreamOptions (URL::ParameterHandling::inAddress)
.withConnectionTimeoutMs (1000)
.withNumRedirectsToFollow (0)))
{
...
}
juce::URL::InputStreamOptions
Class used to create a set of options to pass to the createInputStream() method.
Definition juce_URL.h:350
juce::URL::InputStreamOptions::withConnectionTimeoutMs
InputStreamOptions withConnectionTimeoutMs(int connectionTimeoutMs) const
Specifies a timeout for the request in milliseconds.
juce::URL::InputStreamOptions::withNumRedirectsToFollow
InputStreamOptions withNumRedirectsToFollow(int numRedirectsToFollow) const
Specifies the number of redirects that will be followed before returning a response.
juce::URL::ParameterHandling::inAddress
@ inAddress
Definition juce_URL.h:331
juce::URL::createInputStream
std::unique_ptr< InputStream > createInputStream(const InputStreamOptions &options) const
Attempts to open a stream that can read from this URL.
juce::URL::URL
URL()
Creates an empty URL.

The documentation for this class was generated from the following file:

- juce_core/network/juce_URL.h

## Public Member Functions

| InputStreamOptions (ParameterHandling parameterHandling)
| Constructor.
InputStreamOptions | withProgressCallback (std::function< bool(int bytesSent, int totalBytes)> progressCallback) const
| A callback function to keep track of the operation's progress.
InputStreamOptions | withExtraHeaders (const String &extraHeaders) const
| A string that will be appended onto the headers that are used for the request.
InputStreamOptions | withConnectionTimeoutMs (int connectionTimeoutMs) const
| Specifies a timeout for the request in milliseconds.
InputStreamOptions | withResponseHeaders (StringPairArray *responseHeaders) const
| If this is non-null, all the (key, value) pairs received as headers in the response will be stored in this array.
InputStreamOptions | withStatusCode (int *statusCode) const
| If this is non-null, it will get set to the http status code, if one is known, or 0 if a code isn't available.
InputStreamOptions | withNumRedirectsToFollow (int numRedirectsToFollow) const
| Specifies the number of redirects that will be followed before returning a response.
InputStreamOptions | withHttpRequestCmd (const String &httpRequestCmd) const
| Specifies which HTTP request command to use.
ParameterHandling | getParameterHandling () const noexcept
std::function< bool(int, int)> | getProgressCallback () const noexcept
String | getExtraHeaders () const noexcept
int | getConnectionTimeoutMs () const noexcept
StringPairArray * | getResponseHeaders () const noexcept
int * | getStatusCode () const noexcept
int | getNumRedirectsToFollow () const noexcept
String | getHttpRequestCmd () const noexcept

## Constructors and Destructors

## InputStreamOptions()

juce::URL::InputStreamOptions::InputStreamOptions | ( | ParameterHandling | parameterHandling | ) |

explicit

Constructor.

If parameterHandling is ParameterHandling::inPostData, any URL parameters that have been set will be transferred via the request body data. Otherwise the parameters will be added to the URL address.

Referenced by withConnectionTimeoutMs(), withExtraHeaders(), withHttpRequestCmd(), withNumRedirectsToFollow(), withProgressCallback(), withResponseHeaders(), and withStatusCode().

## Member Functions

## withProgressCallback()

InputStreamOptions juce::URL::InputStreamOptions::withProgressCallback | ( | std::function< bool(int bytesSent, int totalBytes)> | progressCallback | ) | const

nodiscard

A callback function to keep track of the operation's progress.

This can be useful for lengthy POST operations, so that you can provide user feedback.

References InputStreamOptions().

## withExtraHeaders()

InputStreamOptions juce::URL::InputStreamOptions::withExtraHeaders | ( | const String & | extraHeaders | ) | const

nodiscard

A string that will be appended onto the headers that are used for the request.

It must be a valid set of HTML header directives, separated by newlines.

References InputStreamOptions().

## withConnectionTimeoutMs()

InputStreamOptions juce::URL::InputStreamOptions::withConnectionTimeoutMs | ( | int | connectionTimeoutMs | ) | const

nodiscard

Specifies a timeout for the request in milliseconds.

If 0, this will use whatever default setting the OS chooses. If a negative number, it will be infinite.

References InputStreamOptions().

## withResponseHeaders()

InputStreamOptions juce::URL::InputStreamOptions::withResponseHeaders | ( | StringPairArray * | responseHeaders | ) | const

nodiscard

If this is non-null, all the (key, value) pairs received as headers in the response will be stored in this array.

References InputStreamOptions().

## withStatusCode()

InputStreamOptions juce::URL::InputStreamOptions::withStatusCode | ( | int * | statusCode | ) | const

nodiscard

If this is non-null, it will get set to the http status code, if one is known, or 0 if a code isn't available.

References InputStreamOptions().

## withNumRedirectsToFollow()

InputStreamOptions juce::URL::InputStreamOptions::withNumRedirectsToFollow | ( | int | numRedirectsToFollow | ) | const

nodiscard

Specifies the number of redirects that will be followed before returning a response.

N.B. This will be ignored on Android which follows up to 5 redirects.

References InputStreamOptions().

## withHttpRequestCmd()

InputStreamOptions juce::URL::InputStreamOptions::withHttpRequestCmd | ( | const String & | httpRequestCmd | ) | const

nodiscard

Specifies which HTTP request command to use.

If this is not set, then the command will be POST if parameterHandling is set to ParameterHandling::inPostData or if any POST data has been specified via withPOSTData(), withFileToUpload(), or withDataToUpload(). Otherwise it will be GET.

References InputStreamOptions().

## getParameterHandling()

ParameterHandling juce::URL::InputStreamOptions::getParameterHandling | ( |  | ) | const

inline noexcept

## getProgressCallback()

std::function< bool(int, int)> juce::URL::InputStreamOptions::getProgressCallback | ( |  | ) | const

inline noexcept

## getExtraHeaders()

String juce::URL::InputStreamOptions::getExtraHeaders | ( |  | ) | const

inline noexcept

## getConnectionTimeoutMs()

int juce::URL::InputStreamOptions::getConnectionTimeoutMs | ( |  | ) | const

inline noexcept

## getResponseHeaders()

StringPairArray * juce::URL::InputStreamOptions::getResponseHeaders | ( |  | ) | const

inline noexcept

## getStatusCode()

int * juce::URL::InputStreamOptions::getStatusCode | ( |  | ) | const

inline noexcept

## getNumRedirectsToFollow()

int juce::URL::InputStreamOptions::getNumRedirectsToFollow | ( |  | ) | const

inline noexcept

## getHttpRequestCmd()

String juce::URL::InputStreamOptions::getHttpRequestCmd | ( |  | ) | const

inline noexcept

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited